import gtk
import time

class timex:

    def __init__(self):
        self.iconify_adjust_minutes= 0
        self.iconify_time= 0
        self.iconified= False
        self.widgets = {}

    # call with minutes= 0 to stop timer
    def set_timeout_minutes(self,minutes):
        self.iconify_adjust_minutes= minutes
        if self.iconify_adjust_minutes == 0:
            self.iconify_time= 0

    def reset_clock(self):
        if self.iconify_adjust_minutes:
            self.iconify_time= time.time() + (self.iconify_adjust_minutes*60)

    def handle_reset_clock_event(self,widget,event):
        self.reset_clock()

    def handle_window_state_event(self,widget,event):
        new_state = event.new_window_state
        if new_state & gtk.gdk.WINDOW_STATE_ICONIFIED:
            self.widgets[widget.get_name()]= True
        else:
            self.widgets[widget.get_name()] = False
            self.reset_clock()

    # return True if caller should skip processing
    def process_clock(self,widget):
        if self.widgets.has_key(widget.get_name()):
            if self.widgets[widget.get_name()] == True:
                return True
        if self.iconify_time == 0:
            return False
        if time.time() <= self.iconify_time:
            return False
        widget.iconify()
        return True

